#include <mutex>
#include <functional>
#include <map>

// ROS2
#include <rclcpp/rclcpp.hpp>
#include <rclcpp_action/rclcpp_action.hpp>
#include <{{ pkgname }}/action/{{ skill.name }}_skill.hpp>

// ROS1
#include <ros/ros.h>
#include <actionlib/client/simple_action_client.h>
#include <actionlib/client/terminal_state.h>
#include <{{ pkgname }}/{{ skill.name|action_name }}Action.h>

#include "{{ skill.name }}_convert.hpp"

class {{ skill.name|action_name }}ActionBridge : public rclcpp::Node
{
public:
  using Ros2Action = {{ pkgname }}::action::{{ skill.name|action_name }};
  using Ros2GoalHandle = rclcpp_action::ServerGoalHandle<Ros2Action>;
  using Ros1Action = {{ pkgname }}::{{ skill.name|action_name }}Action;
  using Ros1Goal = {{ pkgname }}::{{ skill.name|action_name }}Goal;
  using Ros1Feedback = {{ pkgname }}::{{ skill.name|action_name }}Feedback;
  using Ros1GoalHandle = actionlib::ActionClient<Ros1Action>::GoalHandle;
  using Ros1FeedbackConstPtr = {{ pkgname }}::{{ skill.name|action_name }}FeedbackConstPtr;

  explicit {{ skill.name|action_name }}ActionBridge(const rclcpp::NodeOptions & options = rclcpp::NodeOptions())
  : Node("{{ skill.name }}_bridge", options)
  , action_client_("skill/{{ skill.name }}")
  , goal_accepted_(false)
  {
    RCLCPP_DEBUG(this->get_logger(), "initializing {{ skill.name }} ROS2 server");

    this->action_server_ = rclcpp_action::create_server<Ros2Action>(
      this,
      "skill/{{ skill.name }}",
      std::bind(&{{ skill.name|action_name }}ActionBridge::handle_goal, this, std::placeholders::_1, std::placeholders::_2),
      std::bind(&{{ skill.name|action_name }}ActionBridge::handle_cancel, this, std::placeholders::_1),
      std::bind(&{{ skill.name|action_name }}ActionBridge::handle_accepted, this, std::placeholders::_1));
      RCLCPP_INFO(this->get_logger(), "ROS2 action server created");
  }

  void connect() {
    RCLCPP_INFO(this->get_logger(), "connecting to ROS1 action client");
    this->action_client_.waitForActionServerToStart();
    RCLCPP_INFO(this->get_logger(), "client ready");
  }

private:
  rclcpp_action::Server<Ros2Action>::SharedPtr action_server_;
  actionlib::ActionClient<Ros1Action> action_client_;

  std::mutex accept_mutex_;
  bool goal_accepted_;
  Ros1GoalHandle client_gh_;

  std::map<rclcpp_action::GoalUUID, std::shared_ptr<Ros2GoalHandle>> ros2_id_gh_;
  std::map<rclcpp_action::GoalUUID, std::shared_ptr<Ros1GoalHandle>> ros2_id_ros1_gh_;

  std::shared_ptr<Ros2GoalHandle> get_ros2_handler_from_ros1(Ros1GoalHandle gh) {
    for (auto & x: this->ros2_id_ros1_gh_) {
      if (gh == *(x.second)) {
        auto ros2_gh_ptr = this->ros2_id_gh_[x.first];
        return ros2_gh_ptr;
      }
    }
    return nullptr;
  }

  void feedback_cb(Ros1GoalHandle gh, const Ros1FeedbackConstPtr& fb) {
    RCLCPP_DEBUG(this->get_logger(), "feedback: %f", fb->progress);
    auto ros2_gh_ptr = this->get_ros2_handler_from_ros1(gh);
    auto feedback = std::make_shared<Ros2Action::Feedback>();
    feedback->progress = fb->progress;
    ros2_gh_ptr->publish_feedback(feedback);
  }

  void transition_cb(Ros1GoalHandle gh) {
    RCLCPP_DEBUG(this->get_logger(), "-- transition_cb --");
    auto st = gh.getCommState();
    if (st == actionlib::CommState::StateEnum::DONE) {
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: DONE");
      auto fst = gh.getTerminalState();
      if (fst == actionlib::TerminalState::StateEnum::REJECTED) {
        RCLCPP_WARN(this->get_logger(), "REJECTED");
        this->goal_accepted_ = false;
        this->accept_mutex_.unlock();
      }
      if (fst == actionlib::TerminalState::StateEnum::RECALLED)
        RCLCPP_WARN(this->get_logger(), "RECALLED");
      if (fst == actionlib::TerminalState::StateEnum::PREEMPTED) {
        RCLCPP_WARN(this->get_logger(), "PREEMPTED");
        auto ros2_gh_ptr = this->get_ros2_handler_from_ros1(gh);
        auto result = std::make_shared<Ros2Action::Result>();
        result->state = gh.getResult()->state;
        ros2_gh_ptr->canceled(result);
      }
      if (fst == actionlib::TerminalState::StateEnum::ABORTED) {
        RCLCPP_WARN(this->get_logger(), "ABORTED");
        auto ros2_gh_ptr = this->get_ros2_handler_from_ros1(gh);
        auto result = std::make_shared<Ros2Action::Result>();
        result->state = gh.getResult()->state;
        ros2_gh_ptr->abort(result);
      }
      if (fst == actionlib::TerminalState::StateEnum::SUCCEEDED) {
        RCLCPP_INFO(this->get_logger(), "SUCCEEDED");
        auto ros2_gh_ptr = this->get_ros2_handler_from_ros1(gh);
        auto result = std::make_shared<Ros2Action::Result>();
        result->state = gh.getResult()->state;
        ros2_gh_ptr->succeed(result);
      }
      if (fst == actionlib::TerminalState::StateEnum::LOST)
        RCLCPP_DEBUG(this->get_logger(), "transition_cb: LOST");
    }
    if (st == actionlib::CommState::StateEnum::ACTIVE) {
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: ACTIVE");
      this->goal_accepted_ = true;
      this->accept_mutex_.unlock();
    }
    if (st == actionlib::CommState::StateEnum::WAITING_FOR_GOAL_ACK)
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: WAITING_FOR_GOAL_ACK");
    if (st == actionlib::CommState::StateEnum::PENDING)
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: PENDING");
    if (st == actionlib::CommState::StateEnum::WAITING_FOR_RESULT)
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: WAITING_FOR_RESULT");
    if (st == actionlib::CommState::StateEnum::WAITING_FOR_CANCEL_ACK )
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: WAITING_FOR_CANCEL_ACK");
    if (st == actionlib::CommState::StateEnum::RECALLING )
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: RECALLING");
    if (st == actionlib::CommState::StateEnum::PREEMPTING)
      RCLCPP_DEBUG(this->get_logger(), "transition_cb: PREEMPTING");
  };

  rclcpp_action::GoalResponse handle_goal(
    const rclcpp_action::GoalUUID & uuid,
    std::shared_ptr<const Ros2Action::Goal> goal)
  {
    this->accept_mutex_.lock();
    RCLCPP_DEBUG(this->get_logger(), "handle_goal: mutex lock");

    Ros1Goal g;
    {{ skill.name }}_convert(*goal, g);

    auto client_gh_ = std::make_shared<Ros1GoalHandle>(this->action_client_.sendGoal(g,
      std::bind(&{{ skill.name|action_name }}ActionBridge::transition_cb, this, std::placeholders::_1),
      std::bind(&{{ skill.name|action_name }}ActionBridge::feedback_cb, this, std::placeholders::_1, std::placeholders::_2)));
    this->ros2_id_ros1_gh_[uuid] = client_gh_;

    RCLCPP_INFO(this->get_logger(), "Goal sent to ROS1");
    this->accept_mutex_.lock();
    RCLCPP_DEBUG(this->get_logger(), "handle_goal: mutex lock");
    this->accept_mutex_.unlock();

    if (this->goal_accepted_) {
      RCLCPP_INFO(this->get_logger(), "Goal accepted");
      return rclcpp_action::GoalResponse::ACCEPT_AND_EXECUTE;
    }
    else {
      RCLCPP_WARN(this->get_logger(), "Goal rejected");
      return rclcpp_action::GoalResponse::REJECT;
    }
  }

  rclcpp_action::CancelResponse handle_cancel(
    const std::shared_ptr<Ros2GoalHandle> goal_handle)
  {
    RCLCPP_INFO(this->get_logger(), "Received request to cancel goal");
    auto ros1_gh = this->ros2_id_ros1_gh_[goal_handle->get_goal_id()];
    ros1_gh->cancel();
    return rclcpp_action::CancelResponse::ACCEPT;
  }

  void handle_accepted(const std::shared_ptr<Ros2GoalHandle> goal_handle)
  {
    RCLCPP_INFO(this->get_logger(), "Executing goal");
    this->ros2_id_gh_[goal_handle->get_goal_id()] = goal_handle;
  }
};

void spinThread()
{
  ros::spin();
}

int main(int argc, char ** argv)
{
  // ROS 2
  printf("Initializing ROS2\n");
  rclcpp::init(argc, argv);

  // ROS 1 node
  printf("Initializing ROS1 Node\n");
  ros::init(argc, argv, "{{ skill.name }}_bridge");
  ros::NodeHandle ros1_node;

  // Bridge
  auto action_server = std::make_shared<{{ skill.name|action_name }}ActionBridge>();

  // ROS 1 asynchronous spinner
  ros::AsyncSpinner async_spinner(1);
  async_spinner.start();

  action_server->connect();

  // ROS 2 spinning loop
  rclcpp::executors::SingleThreadedExecutor executor;
  while (ros1_node.ok() && rclcpp::ok()) {
    executor.spin_node_once(action_server, std::chrono::milliseconds(100));
    //executor.spin_node_some(ros2_node);
  }

  return 0;
}
